/*
 *  acos() - arccosine
 *
 *  This file is a staight-forward translation of a VHDL package.  The
 *  original VHDL package is the file mathpack.vhd in the directory:
 *
 *  http://tech-www.informatik.uni-hamburg.de/vhdl/packages/mathpack
 *
 *  The mathpack.vhd file has the following license:
 *
 *  "This source file may be used and distributed without restriction.
 *   No declarations or definitions shall be added to this package. 
 *   This package cannot be sold or distributed for profit."
 *
 *  The translation into C was performed by Joel Sherrill <joel@OARcorp.com> 
 *  and the original license applies to the C version.
 *
 *  acos.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE NAME(acos) (DATA_TYPE _x)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;

  /* returns  0 < acos X < PI; | X | <= 1 */

  if ( (x > 1.0) || (x < -1.0) ) {               /* abs(x) > 1.0 */
    return NAME(nan)();
  }

  if ( (x > 0.9) || (x < -0.9 ) ) {              /* abs(x) > 0.9 */
    if ( x > 0.0 )
      return SUBNAME(atan)(SUBNAME(sqrt)(1.0 - x*x)/x);
    return M_PI - SUBNAME(atan)(SUBNAME(sqrt)(1.0 - x*x)/x);
  } else
    return M_PI_2 - SUBNAME(atan)(x/SUBNAME(sqrt)(1.0 - x*x));
}

