/*
 *  acosh() - inverse hyperbolic cosine 
 *
 *  This file is a staight-forward translation of a VHDL package.  The
 *  original VHDL package is the file mathpack.vhd in the directory:
 *
 *  http://tech-www.informatik.uni-hamburg.de/vhdl/packages/mathpack
 *
 *  The mathpack.vhd file has the following license:
 *
 *  "This source file may be used and distributed without restriction.
 *   No declarations or definitions shall be added to this package.
 *   This package cannot be sold or distributed for profit."
 *
 *  The translation into C was performed by Joel Sherrill <joel@OARcorp.com>
 *  and the original license applies to the C version.
 *
 *  acosh.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE NAME(acosh)(DATA_TYPE _x)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;

  /* if abs x >= 1.0 then out of range */
  if ( x <= -1.0 || x >= 1.0 ) {
    return NAME(nan)();
  }

  /* returns ln( X + sqrt( X**2 - 1));   X >= 1 */
  return (DATA_TYPE) SUBNAME(log)( x + SUBNAME(sqrt)( x*x - 1.0));
}

