/*
 *  atan() - arctangent
 *
 *  This file is a staight-forward translation of a VHDL package.  The
 *  original VHDL package is the file mathpack.vhd in the directory:
 *
 *  http://tech-www.informatik.uni-hamburg.de/vhdl/packages/mathpack
 *
 *  The mathpack.vhd file has the following license:
 *
 *  "This source file may be used and distributed without restriction.
 *   No declarations or definitions shall be added to this package.
 *   This package cannot be sold or distributed for profit."
 *
 *  The translation into C was performed by Joel Sherrill <joel@OARcorp.com>
 *  and the original license applies to the C version.
 *
 *  atan.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif
#include "cordic_.h"

#include <stdio.h>

DATA_TYPE NAME(atan)(DATA_TYPE _x)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  SUBDATA_TYPE cr;

  /* returns  -PI/2 < atan X < PI/2 */
  SUBNAME(CORDIC)(1.0,x,0.0,MAXIMUM_ITERATIONS,VECTORING,NULL,NULL,&cr);
  return (DATA_TYPE)cr;
}

