/*
 *  atan2() - arctangent of y/x
 *
 *  atan2.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE atan2(DATA_TYPE _y, DATA_TYPE _x)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  SUBDATA_TYPE y = (SUBDATA_TYPE) _y;
  SUBDATA_TYPE adjustment;
  int          quadrant;

  quadrant = 0;

  if ( x < 0.0 )
    quadrant = 2;

  if ( y < 0.0 )
    quadrant++;

  if ( x == 0.0 ) {
    if ( quadrant & 1 )     /* quadrants 1 and 3 */
      return 3.0*M_PI_2;
    if ( y == 0.0 )
      return 0.0;
    return M_PI_2;
  }

  if ( y == 0.0 ) {
    if ( quadrant & 2 )     /* quadrants 0 and 2 */
       return M_PI;
    return 0.0;
  }

  switch( quadrant ) {
    case 0: adjustment = 0.0; break;
    case 1: adjustment = 2.0 * M_PI; break;
    case 2:
    case 3: adjustment = M_PI; break;
  }

  return (DATA_TYPE)(adjustment + SUBNAME(atan)( y/x ));
}
