/*
 *  copysign() - copy sign of a number
 *
 *  Returns  a value whose absolute value matches x, but whose
 *  sign matches that of y.
 *
 *  COPYRIGHT:
 *    Copyright (c) 2000, On-Line Applications Research Corporation (OAR)
 *
 *  copysign.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE NAME(copysign)(DATA_TYPE _x, DATA_TYPE _y)
{
  SUBDATA_TYPE result;
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  SUBDATA_TYPE y = (SUBDATA_TYPE) _y;

  result = SUBNAME(fabs)(x);
  
  if ( y < 0.0 )
    return -x;
  return x;
}
