/*
 *  cos() - cosine
 *
 *  This file is a staight-forward translation of a VHDL package.  The
 *  original VHDL package is the file mathpack.vhd in the directory:
 *
 *  http://tech-www.informatik.uni-hamburg.de/vhdl/packages/mathpack
 *
 *  The mathpack.vhd file has the following license:
 *
 *  "This source file may be used and distributed without restriction.
 *   No declarations or definitions shall be added to this package.
 *   This package cannot be sold or distributed for profit."
 *
 *  The translation into C was performed by Joel Sherrill <joel@OARcorp.com>
 *  and the original license applies to the C version.
 *
 *  cos.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif
#include "cordic_.h"

DATA_TYPE NAME(cos)(DATA_TYPE _x)
{
  SUBDATA_TYPE  x = (SUBDATA_TYPE) _x;
  int           n;
  SUBDATA_TYPE  cr1, cr2;

  if ( (x < 1.6 ) && (x > -1.6) ) {
    SUBNAME(CORDIC)( KC, 0.0, x, 27, ROTATION, &cr1, NULL, NULL);
    return cr1;
  }

  n = (int) (x / M_PI_2);
  SUBNAME(CORDIC)( KC, 0.0, x - (SUBDATA_TYPE)(n) * M_PI_2, 27,
             ROTATION, &cr1, &cr2, NULL);
  switch ( n % 4 ) {
    case 0:
      return cr1;
    case 1:
      return cr2;
    case 2:
      return -cr1;
    case 3:
      return -cr2;
  }
  return 0;
}

