/*
 *  floor() - floor
 *
 *  COPYRIGHT:
 *    Copyright (c) 2000, On-Line Applications Research Corporation (OAR)
 *
 *  floor.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif
#include <limits.h>

DATA_TYPE NAME(floor)(DATA_TYPE _x)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  SUBDATA_TYPE rd;

  if ( x == 0.0 )
    return 0.0;

  /*  Returns largest integer value (as real) not greater than X
   *  No conversion to an integer type is expected, so truncate
   *  cannot overflow for large arguments.
   */

  if ( SUBNAME(fabs)(x) > (double) MAXIMUM_INTEGER )
    return x;

  rd = (double)((LONG_TYPE)x);
  if ( x > 0.0 ) {
    if ( rd <= x )
      return rd;
    return rd - 1.0;
  }
  /* x < 0.0 */
  if ( rd >= x )
    return rd;
  return (DATA_TYPE)(rd + 1.0);
}
