/*
 *  hypot() - hypotenuse (distance from origin)
 *
 *  Written by Joel Sherrill <joel@OARcorp.com>.
 * 
 *  This source file may be used and distributed without restriction.
 *
 *  COPYRIGHT:
 *    Copyright (c) 2000, On-Line Applications Research Corporation (OAR)
 *
 *  hypot.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE NAME(hypot)(DATA_TYPE _x, DATA_TYPE _y)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  SUBDATA_TYPE y = (SUBDATA_TYPE) _y;

  if ( x < 0.0 ) {
    /* errno = EDOM according to Linux man page */
    return 0.0;
  }

  return (DATA_TYPE)SUBNAME(sqrt)( x*x + y*y );
}
