/*
 *  ilogb() - get exponent of floating point
 *
 *  All non zero, normal numbers can be described as m * 2**p. ilogb() and
 *  ilogbf() examine the argument val, and return p. The functions frexp()
 *  and frexpf() are similar to ilogb() and ilogbf(), but also return m. 
 *
 *  COPYRIGHT:
 *    Copyright (c) 2000, On-Line Applications Research Corporation (OAR)
 *
 *  ilogb.c,v 1.2 2000/11/13 22:58:38 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

int NAME(ilogb)(DATA_TYPE  _x)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  int          exponent;
  double       fraction;

  fraction = SUBNAME(frexp)( x, &exponent );
  return exponent;
}

