/****************************************************************
 * (C) Copyright 1997 Jouko Holopainen     See README
 *
 * Most of these are from 
 *  "Computer Approximations", J. Hart, et al, 1968, Wiley
 *
 ****************************************************************/


#ifndef DATA_TYPE
#include "double_setup.h"
#endif

#include <math.h>

/****************************************************************
 * FUNCTION:    modf
 * DESCRIPTION: Calculates integral part and fraction
 * INPUT:
 *  PARAMETERS: value - double
 *              iptr - pointer ot integral part
 *  GLOBALS:    none
 * OUTPUT:
 *  RESULT:     double - fraction of value
 *  GLOBALS:    none
 * CALLS:       none
 * COMMENTS:    none
 ****************************************************************/

DATA_TYPE NAME(modf)(DATA_TYPE value, DATA_TYPE *iptr)
{
  *iptr = floor( (double) value);
  return value - *iptr;

}
