/*
 *  nextafter() - get next representable number
 *
 *  COPYRIGHT:
 *    Copyright (c) 2000, On-Line Applications Research Corporation (OAR)
 *
 *  nextafter.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE NAME(nextafter)(DATA_TYPE _x, DATA_TYPE _direction)
{
  SUBDATA_TYPE x         = (SUBDATA_TYPE) _x;
  SUBDATA_TYPE direction = (SUBDATA_TYPE) _direction;

  if ( SUBNAME(isnan)(_x) || SUBNAME(isinf)(_x) ) {
    return _x;
  }
  
  if ( direction < 0 ) {
    if ( x == MIN ) {
     return NAME(nan)();
    }
    return x - MIN;
  }
  if ( x == MAX ) {
     return NAME(nan)();
  }
  return (DATA_TYPE)(x + DBL_MIN);
}

