/*
 *  scalbn() - scale by integer
 *
 *  NOTE: This routine is supposed to be more efficient and scale
 *        by directly manipulating the exponent.  The goal of this
 *        implementation is to remain simple and portable so we
 *        will just use ldexp().
 *
 *  COPYRIGHT:
 *    Copyright (c) 2000, On-Line Applications Research Corporation (OAR)
 *
 *  scalbn.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE NAME(scalbn)(DATA_TYPE _x, int exponent)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  return (DATA_TYPE)SUBNAME(ldexp)( x, exponent );
}

