/*
 *  tan() - tangent
 *
 *  This file is a staight-forward translation of a VHDL package.  The
 *  original VHDL package is the file mathpack.vhd in the directory:
 *
 *  http://tech-www.informatik.uni-hamburg.de/vhdl/packages/mathpack
 *
 *  The mathpack.vhd file has the following license:
 *
 *  "This source file may be used and distributed without restriction.
 *   No declarations or definitions shall be added to this package.
 *   This package cannot be sold or distributed for profit."
 *
 *  The translation into C was performed by Joel Sherrill <joel@OARcorp.com>
 *  and the original license applies to the C version.
 *
 *  tan.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */


#ifndef DATA_TYPE
#include "double_setup.h"
#endif
#include "cordic_.h"

DATA_TYPE NAME(tan)(DATA_TYPE _x)
{
  SUBDATA_TYPE x = (SUBDATA_TYPE) _x;
  SUBDATA_TYPE x1, y1;
  int n;

  n = (int) (x / M_PI_2);

  SUBNAME(CORDIC)( KC, 0.0, x - (SUBDATA_TYPE)n * M_PI_2,
          MAXIMUM_ITERATIONS, ROTATION, &x1, &y1, NULL );

  if ( (n % 2) == 0 )
    return y1/x1;
  return -x1/y1;
}


