/*
 *  CORDIC Prototypes used by trig functions
 *
 *  cordic_.h,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */

#ifndef __CORDIC__h
#define __CORDIC__h

/*
 *  XXX may want to be CPU specific
 */

#define MAXIMUM_ITERATIONS 27

/*
 * CORDIC Behavior constants
 */

#define ROTATION 0
#define VECTORING 1
#define KC 6.0725293500888142e-01

/*
 *  XXX may want multiple data type versions of this
 */

void CORDIC(
  double x0,
  double y0, 
  double z0,
  int    n,                  /* precision factor */
  int    cordic_mode,        /* rotation (z -> 0) or vectoring (y -> 0) */
  double *xout,
  double *yout,
  double *zout
);

#endif
/* end of include file */
