#include "machine.h"

#define LOG_E           0.4342944819032518276511289   /* log(e) */
#
#define SQRT_EPSILON    0.000001
#define LOG_EPSILON     0.0000001
#define EXP_EPSILON     0.000001
# define M_E		2.7182818284590452354	/* e */
# define M_LOG2E	1.4426950408889634074	/* log_2 e */
# define M_LOG10E	0.43429448190325182765	/* log_10 e */
# define M_LN2		0.69314718055994530942	/* log_e 2 */
# define M_LN10		2.30258509299404568402	/* log_e 10 */
# define M_PI           3.14159265358979323846  /* pi */
# define M_PI_2         1.57079632679489661923  /* pi/2 */
# define M_PI_4         0.78539816339744830962  /* pi/4 */
# define M_1_PI         0.31830988618379067154  /* 1/pi */
# define M_2_PI         0.63661977236758134308  /* 2/pi */
# define M_2_SQRTPI     1.12837916709551257390  /* 2/sqrt(pi) */
# define M_PIl          3.1415926535897932384626433832795029L  /* pi */
# define M_PI_2l        1.5707963267948966192313216916397514L  /* pi/2 */
# define M_PI_4l        0.7853981633974483096156608458198757L  /* pi/4 */
# define M_1_PIl        0.3183098861837906715377675267450287L  /* 1/pi */
# define M_2_PIl        0.6366197723675813430755350534900574L  /* 2/pi */
# define M_2_SQRTPIl    1.1283791670955125738961589031215452L  /* 2/sqrt(pi) */


/* if we have 64 bit types, use them */
#if defined(LONG_LONG_MAX) && !defined(AVOID_LONG_LONG)
#define MAXIMUM_INTEGER LONG_LONG_MAX
#define LONG_TYPE       long long
#else
#define MAXIMUM_INTEGER LONG_MAX
#define LONG_TYPE       long
#endif

float powf(float x, float y);


float frexpf(float val, int *exp);
long double frexpld(long double val, int *exp);


int isnan(double arg);
int isinf(double arg);
double infinity(void);
double nan(void);


float tanf(float x);
float sqrtf(float x);
float sinf(float x);
float scalbnf(float x, int exponent);
float remainderf(float x, float y);
float powf(float x, float y);
float nextafterf(float x, float direction);
float nanf(void);
float modff(float value, float *iptr);
float logf(float x);
float log10f( float _v );
float ldexpf(float x, int exponent);
float infinityf(void);
float hypotf(float x, float y);
float fmodf(float x, float y);
float floorf(float x);
float fabsf(float x);
float expf(float x);
float cosf(float x);
float copysignf(float x, float y);
float ceilf( float value );
float cbrtf(float x);
float atanf(float x);
float atanhf(float x);
float asinf(float x);
float asinhf(float x);
float acosf(float x);
float acoshf(float x);
int ilogbf(double x);
int isnanf(float x);
int isinff( float x);
int finitef(float x);


long double tanld(long double x);
long double sqrtld(long double x);
long double sinld(long double x);
long double scalbnld(long double x, int exponent);
long double remainderld(long double x, long double y);
long double powld(long double x, long double y);
long double nextafterld(long double x, long double direction);
long double nanld(void);
long double modfld(long double value, long double *iptr);
long double logld(long double x);
long double log10ld( long double _v );
long double ldexpld(long double x, int exponent);
long double infinityld(void);
long double hypotld(long double x, long double y);
long double fmodld(long double x, long double y);
long double floorld(long double x);
long double fabsld(long double x);
long double expld(long double x);
long double cosld(long double x);
long double copysignld(long double x, long double y);
long double ceilld( long double value );
long double cbrtld(long double x);
long double atanld(long double x);
long double atanhld(long double x);
long double asinld(long double x);
long double asinhld(long double x);
long double acosld(long double x);
long double acoshld(long double x);
int isnanld(long double x);
int isinfld( long double x);
int ilogbld(double x);
int finiteld(long double x);

