/*
 *  sqrt() 
 *
 *  Wrapper for c30 assembly method.  All error checking should be done
 *  in c prior to the assembly call.
 *
 *  COPYRIGHT:
 *    Copyright (c) 2000, On-Line Applications Research Corporation (OAR)
 *
 *  sqrt.c,v 1.1.1.1 2000/11/13 21:58:23 jennifer Exp
 */


#ifndef DATA_TYPE
#include "double_setup.h"
#endif

DATA_TYPE NAME( sqrt )( DATA_TYPE value )
{

  /*
   * Check error codes
   */

  if ( value < 0 )
    return NaN; 

  if ( value == 0 )
    return (DATA_TYPE) 0.0;
  
  /*
   * do real work in _log.
   */

  return (DATA_TYPE) _sqrt( (long double) value );
}

