/*
 *  Startup wrapper for all math tests.  Can be used natively or as
 *  initialization task including configuration information for RTEMS.
 */

extern int test_main();

#if !defined(__rtems__)

int main()
{
  int status;

  status = test_main();
  exit( status );
}

#else
#define TEST_INIT

#include <bsp.h>
#include <hwapi/channel_termios.h>
#include <stdio.h>

rtems_task Init(
  rtems_task_argument ignored
)
{
  int status;

  status = test_main();
  exit( status );
}

#ifdef c3xsim
/* configuration information */
#include <serial_sem.h>
rtems_driver_address_table Device_drivers[] = {
  CONSOLE_DRIVER_TABLE_ENTRY,
  CLOCK_DRIVER_TABLE_ENTRY,
};
#else
rtems_driver_address_table Device_drivers[] = {
  CONSOLE_DRIVER_TABLE_ENTRY,
  CLOCK_DRIVER_TABLE_ENTRY,
};
#endif

#define CONFIGURE_INIT
#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
#define CONFIGURE_MAXIMUM_TASKS                1
#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER

#include <confdefs.h>
#endif /* if defined(__rtems__) */
/* end of file */
