#include <float.h>
#include <stdio.h>
#include "test.h"

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE  1
#endif

/*
 * For breaking in the optimized code.
 */

int break_here;


/*
 * Validate
 *    Validates the "name" produced value
 *    of expected +/- tol for the original
 *    number.
 */

int Valid(
  double expected,
  double value,
  double tol
)
{
  double     min;
  double     max;
  double     offset;
  int        result = TRUE;

  /*
   * Note NaN has no equivalent on the c30 processor
   */

  if ( expected == DBL_MIN )
    min = expected;
  else
    min = expected - tol;

  if ( expected == DBL_MAX )
    max = expected;
  else
    max = expected + tol;

  if ( ( value < min ) || (value > max)){
    result = FALSE;
    offset = expected - value;
    printf(
      "        ==>Error %e expected %e:%e (offset: %e)\n",
      value,
      min,
      max, 
      offset
    );
    break_here++;
  }

  return FALSE;
}

int  param1_test(
  param1_test_t *ptr
) 
{
  unsigned int i;
  double       value;
  int          passed = TRUE;

  for (i=0; i < ptr->size; i++){
    printf("%d) %s( %e ) ", i, ptr->name, ptr->table[i].x );
    value = ptr->method( ptr->table[i].x );
    if ( ! Valid(ptr->table[i].v, value, ptr->tolerance) )
      passed = FALSE;
    printf("\n");
  }

  return passed;
}

int param2_test(
  param2_test_t *ptr
)
{
  unsigned int   i;
  double         value;
  int            passed;

  for ( i=0; i < ptr->size; i++ ){
    printf("%d) %s( %e,%e ) ", i, ptr->name,ptr->table[i].x,ptr->table[i].y);
    value = ptr->method( ptr->table[i].x, ptr->table[i].y );
    if ( !Valid( ptr->table[i].v, value, ptr->tolerance ) )
      passed = FALSE;
    printf( "\n" );
  }

  return passed;
}
