
#include <stdio.h>

typedef struct {
  double x;   /* parameter       */
  double v;   /* expected result */
}param1_expect_t;

typedef struct {
  double x;   /* parameter 1     */
  double y;   /* parameter 2     */
  double v;   /* expected result */
}param2_expect_t;


typedef double (*double_p1_method)(
  double x
);

typedef double (*double_p2_method)(
  double x,				   
  double y 
);

typedef struct {
  param1_expect_t    *table;
  size_t             size;
  char               *name;
  double_p1_method   method;
  double             tolerance;
}param1_test_t;
  
typedef struct {
  param2_expect_t    *table;
  size_t             size;
  char               *name;
  double_p2_method   method;
  double             tolerance;
}param2_test_t;
  
/*
 * XXX - Defined based upon the processor type.
 */

#include <float.h>
#include <math.h>
#define NaN    DBL_MAX
#define Inf    DBL_MAX
#define NInf   DBL_MIN

void Validate(
  double expected,
  double value,
  double tol
);

int param1_test(
  param1_test_t *ptr
); 

int param2_test(
  param2_test_t *ptr
); 

int test_main();




